
package de.ivu.elect.presentation.entschaedigung;

import static org.apache.commons.lang3.StringUtils.isBlank;

import java.util.Collection;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.entschaedigung.boundary.AuszahlungConversationSelect;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungEdit;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungSearch.EntschaedigungenInAuszahlungObsoleteSearchResult;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungSearch.EntschaedigungenInAuszahlungObsoleteSearchResultFormatted;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungSearchParameters;
import de.ivu.elect.business.entschaedigung.entity.Auszahlung;
import de.ivu.elect.business.entschaedigung.entity.Entschaedigung;
import de.ivu.elect.business.search.control.AbstractElectSearchParameters;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.menu.AbstractMenuModelBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.jee.presentation.search.AbstractSearchParameters;
import de.ivu.elect.presentation.entschaedigung.form.AuszahlungViewFormBuilder;
import de.ivu.elect.presentation.entschaedigung.menu.EntschaedigungInAuszahlungObsoleteSearchMenu;
import de.ivu.elect.presentation.entschaedigung.menu.EntschaedigungInAuszahlungSearchMenu;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId("539")
@Named(AbstractEntschaedigungSearchView.COMPONENT_NAME)
public class EntschaedigungInAuszahlungSearchView extends AbstractEntschaedigungSearchView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient EntschaedigungEdit entschaedigungEdit;

  @Inject
  private transient AuszahlungConversationSelect auszahlungConversationSelect;

  @Inject
  private transient AuszahlungViewFormBuilder auszahlungViewFormBuilder;

  @Inject
  private transient EntschaedigungInAuszahlungSearchMenu entschaedigungInAuszahlungSearchMenu;

  @Inject
  private transient EntschaedigungInAuszahlungObsoleteSearchMenu entschaedigungInAuszahlungObsoleteSearchMenu;

  private boolean searchEntschaedigungenInAuszahlungObsoleteRequested;

  private int anzahlEntschaedigungenInAuszahlungObsoleteVeraendert;

  private int anzahlEntschaedigungenInAuszahlungObsoleteAusgezahlt;

  public EntschaedigungInAuszahlungSearchView() {
    super();
  }

  @Override
  protected AbstractGebietSecurityFilter<Entschaedigung> getGebietSecurityFilter() {
    return KEIN_GEBIET_SECURITY_FILTER;
  }

  private String getParentViewId() {
    return AbstractAuszahlungSearchView.VIEW_ID;
  }

  public String getPageHeader() {
    String msgKeyPrefix = "entschaedigung.";

    if (isSearchEntschaedigungenInAuszahlungObsoleteRequested()) {
      msgKeyPrefix += "obsolete.";
    }

    if (isAuszahlungSelected()) {
      return getMessage(msgKeyPrefix + "by.auszahlung.search.page.header", entityMeta.getMehrzahlMessage(), getSelectedAuszahlung().getBezeichnung());
    }

    return getMessage(msgKeyPrefix + "search.page.header", entityMeta.getMehrzahlMessage());
  }

  private boolean isSearchEntschaedigungenInAuszahlungObsoleteRequested() {
    return searchEntschaedigungenInAuszahlungObsoleteRequested;
  }

  private void setSearchEntschaedigungenInAuszahlungObsoleteRequested(boolean searchEntschaedigungenInAuszahlungObsoleteRequested) {
    this.searchEntschaedigungenInAuszahlungObsoleteRequested = searchEntschaedigungenInAuszahlungObsoleteRequested;
  }

  /**
   * @deprecated To be removed...
   * @see EntschaedigungInAuszahlungSearchView#initSearchParametersByContext
   */
  @Deprecated
  @Override
  public void presetSearchParameters() {
    // To be removed...
  }

  @Override
  protected void initSearchParametersByContext() {
    super.initSearchParametersByContext();

    EntschaedigungSearchParameters entschaedigungSearchParameters = super.getSearchParameters();
    entschaedigungSearchParameters.setAuszahlung(getSelectedAuszahlung());

    if (isSearchEntschaedigungenInAuszahlungObsoleteRequested()) {
      entschaedigungSearchParameters.setLimit(AbstractElectSearchParameters.NO_LIMIT); // Immer in gesamter Auszahlung suchen!!!
    }
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    if (isAuszahlungSelected()) {
      Auszahlung auszahlung = getSelectedAuszahlung();

      if (!auszahlung.isBearbeitbar()) {
        addWarningMessage("auszahlung.edit.entity.readonly.message");
      }

      auszahlungViewFormBuilder.addDateiExportProperties(formBuilder, auszahlung, true);

      formBuilder.addSeparator();
    }

    if (!isSearchEntschaedigungenInAuszahlungObsoleteRequested()) {
      String wildcardTooltip = getMessage(AbstractSearchParameters.WILDCARD_TOOLTIP_MSG_KEY);

      EntschaedigungSearchParameters entschaedigungSearchParameters = super.getSearchParameters();

      formBuilder.addProperty(entschaedigungSearchParameters.getFamiliennameProperty()).withTooltip(wildcardTooltip);
      formBuilder.addProperty(entschaedigungSearchParameters.getVornameProperty()).withTooltip(wildcardTooltip);
    }
  }

  public AbstractMenuModelBuilder getSearchMenu() {
    if (isSearchEntschaedigungenInAuszahlungObsoleteRequested()) {
      return entschaedigungInAuszahlungObsoleteSearchMenu;
    }

    return entschaedigungInAuszahlungSearchMenu;
  }

  @Override
  protected List<Entschaedigung> performSearch() {
    if (isSearchEntschaedigungenInAuszahlungObsoleteRequested()) {
      EntschaedigungenInAuszahlungObsoleteSearchResult entschaedigungenInAuszahlungObsoleteSearchResult = search.getSearchResultEntschaedigungenInAuszahlungObsolete(getSearchParameters(),
          getEagerLoadingCollector());

      anzahlEntschaedigungenInAuszahlungObsoleteVeraendert = entschaedigungenInAuszahlungObsoleteSearchResult.getEntschaedigungenVeraendert().size();
      anzahlEntschaedigungenInAuszahlungObsoleteAusgezahlt = entschaedigungenInAuszahlungObsoleteSearchResult.getEntschaedigungenAusgezahlt().size();

      return entschaedigungenInAuszahlungObsoleteSearchResult.getEntschaedigungen();
    }

    return super.performSearch();
  }

  @Override
  public void onSearchResultLoaded() {
    super.onSearchResultLoaded();

    if (isSearchEntschaedigungenInAuszahlungObsoleteRequested()) {
      Collection<Entschaedigung> entschaedigungenInAuszahlungObsolete = getSearchResult(); // Cf. performSearch...
      int anzahlEntschaedigungenInAuszahlungObsolete = entschaedigungenInAuszahlungObsolete.size();

      EntschaedigungenInAuszahlungObsoleteSearchResultFormatted entschaedigungenInAuszahlungObsoleteSearchResultFormatted = new EntschaedigungenInAuszahlungObsoleteSearchResultFormatted(getMessages(),
          anzahlEntschaedigungenInAuszahlungObsolete, anzahlEntschaedigungenInAuszahlungObsoleteVeraendert, anzahlEntschaedigungenInAuszahlungObsoleteAusgezahlt);

      if (anzahlEntschaedigungenInAuszahlungObsolete > 0) {
        addErrorMessage(entschaedigungenInAuszahlungObsoleteSearchResultFormatted.getFormatKey(), entschaedigungenInAuszahlungObsoleteSearchResultFormatted.getFormatParams());
      } else {
        addInfoMessage(entschaedigungenInAuszahlungObsoleteSearchResultFormatted.getFormatKey(), entschaedigungenInAuszahlungObsoleteSearchResultFormatted.getFormatParams());
      }
    }
  }

  @Override
  public boolean isBtnSearchRendered() {
    return super.isBtnSearchRendered() && !isSearchEntschaedigungenInAuszahlungObsoleteRequested();
  }

  @Override
  @Redirect
  public String search() {
    return searchEntschaedigungenInAuszahlung();
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ENTSCHAEDIGUNG_SEARCH)
  public String searchEntschaedigungenInAuszahlung() {
    setSearchEntschaedigungenInAuszahlungObsoleteRequested(false);

    return super.search();
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ENTSCHAEDIGUNG_SEARCH)
  public String searchEntschaedigungenInAuszahlungObsolete() {
    reset();

    setSearchEntschaedigungenInAuszahlungObsoleteRequested(true);

    return getViewId();
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ENTSCHAEDIGUNG_DELETE)
  public String deleteAll() {
    reset();

    entschaedigungEdit.deleteAllInAuszahlung(getSelectedAuszahlung());

    addInfoMessage("entschaedigung.edit.action.delete.all.success.message", entityMeta.getMehrzahlMessage());

    return getViewId();
  }

  @Override
  @Redirect
  public String reset() {
    setSearchEntschaedigungenInAuszahlungObsoleteRequested(false);

    anzahlEntschaedigungenInAuszahlungObsoleteVeraendert = 0;
    anzahlEntschaedigungenInAuszahlungObsoleteAusgezahlt = 0;

    return super.reset();
  }

  @Override
  public boolean isBtnGoBackRendered() {
    return true;
  }

  @Override
  @Redirect
  public String goBack() {
    reset();

    String outcome = super.goBack();

    if (isBlank(outcome)) {
      return getParentViewId();
    }

    return outcome;
  }

  private boolean isAuszahlungSelected() {
    return auszahlungConversationSelect.isSelected();
  }

  private Auszahlung getSelectedAuszahlung() {
    return auszahlungConversationSelect.getEntity();
  }
}
